




 





















#include "clock.h"






float      clock_Akku[clock_TYPESIZE];
CLOCK_TMS  clock_Counters[clock_TYPESIZE];






void clock_Init(void)

{
  int i;

  for (i=0;i<clock_TYPESIZE;i++) {
    clock_InitCounter(i);
  }
}

void clock_InitCounter(CLOCK_CLOCKS ClockCounter)

{
  clock_Akku[ClockCounter] = 0;
}


void clock_StartCounter(CLOCK_CLOCKS ClockCounter)

{
#ifndef CLOCK_NO_TIMING
  ftime(&(clock_Counters[ClockCounter]));
#endif
}


void clock_StopPassedTime(CLOCK_CLOCKS ClockCounter) 

{
#ifndef CLOCK_NO_TIMING
  CLOCK_TMS    newtime;
  ftime(&newtime);
  clock_Akku[ClockCounter] = (float) (newtime.time-clock_Counters[ClockCounter].time)+((newtime.millitm-clock_Counters[ClockCounter].millitm))/(float)1000;
#endif
}


void clock_StopAddPassedTime(CLOCK_CLOCKS ClockCounter) 

{
#ifndef CLOCK_NO_TIMING
  CLOCK_TMS    newtime;
  ftime(&newtime);
  clock_Akku[ClockCounter] += (float) (newtime.time-clock_Counters[ClockCounter].time)+((newtime.millitm-clock_Counters[ClockCounter].millitm))/(float)1000;
#endif
}


float clock_GetSeconds(CLOCK_CLOCKS ClockCounter)

{
#ifndef CLOCK_NO_TIMING
  CLOCK_TMS    newtime;
  ftime(&newtime);
  return ((float) (newtime.time-clock_Counters[ClockCounter].time)+((newtime.millitm-clock_Counters[ClockCounter].millitm))/(float)1000);
#else
  return 0;
#endif
}


void clock_PrintTime(CLOCK_CLOCKS ClockCounter)

{
#ifndef CLOCK_NO_TIMING
  NAT   hours, minutes;
  float seconds;

  seconds   = clock_Akku[ClockCounter];
  hours     = (NAT)seconds/3600;
  seconds  -= hours*3600;
  minutes   = (NAT)seconds/60;
  seconds  -= (minutes*60);
  if (seconds >= 10.0)
    printf("%u:%02u:%2.2f",hours,minutes,seconds);
  else
    printf("%u:%02u:0%2.2f",hours,minutes,seconds);
#else
  printf(" No Timing on this machine. ");
#endif
}
