




 





















#ifndef _COMPONENT_
#define _COMPONENT_





#include "list.h"





typedef struct cliteral {
  BOOL  used;              
  int   litindex;           
  LIST  litvarlist;        
} *CLITERAL, CLITERAL_NODE;


typedef struct litptr {
  CLITERAL *litptr;             
  int     length;              
} *LITPTR, LITPTR_NODE;





static __inline__ BOOL literal_GetUsed(CLITERAL C)
{
  return C->used;
}

static __inline__ int literal_GetLitIndex(CLITERAL C)
{
  return C->litindex;
}

static __inline__ LIST literal_GetLitVarList(CLITERAL C)
{
  return C->litvarlist;
}

static __inline__ void literal_PutUsed(CLITERAL C,BOOL Bool)
{
  C->used = Bool;
}

static __inline__ void literal_PutLitIndex(CLITERAL C, int I)
{
  C->litindex = I;
}

static __inline__ void literal_PutLitVarList(CLITERAL C, LIST L)
{
  C->litvarlist = L;
}

static __inline__ CLITERAL litptr_Literal(LITPTR C, int I)
{
  return C->litptr[I];
}

static __inline__ void litptr_SetLiteral(LITPTR LP, int I, CLITERAL CL)
{
  LP->litptr[I] = CL;
}


static __inline__ int litptr_Length(LITPTR C)
{
  return C->length;
}

static __inline__ void litptr_SetLength(LITPTR C, int n)
{
  C->length = n;
}

static __inline__ void litptr_IncLength(LITPTR C)
{
  (C->length)++;
}

static __inline__ void literal_Free(CLITERAL Lit)
{
  memory_Free(Lit, sizeof(CLITERAL_NODE));
}






void     comp_Init(void);

CLITERAL literal_Create(BOOL, int, LIST);
void     literal_Delete(CLITERAL);

LITPTR   litptr_Create(LIST, LIST);
void     litptr_Delete(LITPTR);
void     litptr_Print(LITPTR);
BOOL     litptr_AllUsed(LITPTR);


#endif
