




 





















#ifndef _FLAGS_
#define _FLAGS_

#include "memory.h"





#define flag_CLEAN -5

typedef enum { flag_ORDKBO, flag_ORDRPOS } flag_ORDTYPE;

typedef enum { flag_AUTO, flag_STDIN, flag_INTERACTIVE, flag_FLOTTER,
	       flag_SOS,

               flag_SPLITS,     flag_MEMORY,     flag_TIMELIMIT,
	       flag_DOCSST,     flag_DOCPROOF,
	       flag_DOCSPLIT,   flag_LOOPS,      flag_PSUB,
	       flag_PREW,       flag_PCON,       flag_PTAUT,
	       flag_POBV,       flag_PSSI,       flag_PSST,
	       flag_PCLR,       flag_PUNC,       flag_PRRE,
               flag_PDER,       flag_PGIVEN,     flag_PLABELS,
	       flag_PKEPT,      flag_PPROBLEM,   flag_PEMPTYCLAUSE,
	       flag_PSTATISTIC, flag_FPMODEL,    flag_FPDFGPROOF,
	       flag_PFLAGS,     flag_POPTSKOLEM, flag_PSTRSKOLEM,
	       flag_PBDC,       flag_PBINC,
	       flag_PAPPLYDEFS,

	       flag_SELECT,     flag_RINPUT,     flag_SORTS,
	       flag_SATINPUT,   flag_WDRATIO,    flag_PREFCON,
	       flag_FULLRED,
	       flag_FUNCWEIGHT, flag_VARWEIGHT,  flag_PREFVAR,
	       flag_BOUNDMODE,  flag_BOUNDSTART, 
	       flag_BOUNDLOOPS, flag_APPLYDEFS,

	       flag_ORD,

	       flag_CNFOPTSKOLEM, flag_CNFSTRSKOLEM, flag_CNFPROOFSTEPS,
	       flag_CNFRENAMING,  flag_CNFPRENAMING, flag_CNFFEQREDUCTIONS,
	       
	       flag_IEMS,       flag_ISOR,
	       flag_IEQR,       flag_IERR,
	       flag_IEQF,       flag_IMPM,       flag_ISPR,
	       flag_IOPM,       flag_ISPM,
	       flag_ISPL,       flag_IORE,       flag_ISRE,
	       flag_ISHY,       flag_IOHY,       flag_IURR,
	       flag_IOFC,       flag_ISFC,
	       flag_IUNR,       flag_IBUR,       flag_IDEF,

	       flag_RFREW,      flag_RBREW,
	       flag_RFCLR,      flag_RBCLR,
	       flag_ROBV,       flag_RUNC,       flag_RTER,
	       flag_RTAUT,      flag_RSST,       flag_RSSI,
	       flag_RFSUB,      flag_RBSUB,      flag_RRRE,
	       flag_RCON,       
	       
	       flag_TDFG2OTTEROPTIONS,

	       flag_MAXFLAG } FLAG_FLAGS;     

typedef int *FLAGSTORE;

extern FLAGSTORE flag_VALUES;
extern FLAGSTORE flag_DEFAULTVALUES;
extern char* flag_STRINGS[flag_MAXFLAG];





static __inline__ FLAGSTORE flag_NewStore()
{
  return (memory_Malloc(flag_MAXFLAG * sizeof(int)));
}

static __inline__ void flag_FreeStore(FLAGSTORE Store)
{
  memory_Free(Store,flag_MAXFLAG * sizeof(int));
}

static __inline__ void flag_InitStoreByDefaults(FLAGSTORE Store)
{
  int i;
  for(i=0;i<flag_MAXFLAG;i++)
    Store[i] = flag_DEFAULTVALUES[i];  
}

static __inline__ void flag_CleanStore(FLAGSTORE Store)
{
  int i;
  for(i=0;i<flag_MAXFLAG;i++)
    Store[i] = flag_CLEAN;  
}

static __inline__ BOOL flag_StoreValueIsClean(FLAGSTORE Store, FLAG_FLAGS FlagId)
{
  return (Store[FlagId] == flag_CLEAN);
}

static __inline__ void flag_TransferSetFlags(FLAGSTORE Store1, FLAGSTORE Store2)
{
  int i;
  for(i=0;i<flag_MAXFLAG;i++)
    if (!flag_StoreValueIsClean(Store1,i))
      Store2[i] = Store1[i];
}

static __inline__ FLAGSTORE flag_GetInstalledStore()
{
  return flag_VALUES;
}

static __inline__ void flag_InstallStore(FLAGSTORE Store)
{
  flag_VALUES = Store;
}

static __inline__ void flag_InstallDefaultStore()
{
  flag_VALUES = flag_DEFAULTVALUES;
}

static __inline__ BOOL flag_IsInstalledStore(FLAGSTORE Store)
{
  return (flag_VALUES == Store);
}

static __inline__ FLAGSTORE flag_DefaultStore()
{
  return flag_DEFAULTVALUES;
}

static __inline__ void flag_SetFlagValue(FLAG_FLAGS FlagId, int Value)
{
#ifdef DEBUG
  if (flag_VALUES == flag_DEFAULTVALUES) {
    misc_StartErrorReport();
    misc_ErrorReport("\n In flag_SetFlagValue: Atempt to modify default");
    misc_ErrorReport("\n flag value.");
    misc_FinishErrorReport();
  }
  if (FlagId < 0 || FlagId >= flag_MAXFLAG) {
    misc_StartErrorReport();
    misc_ErrorReport("\n In flag_SetFlagValue: Rangs of flags exceeded.");
    misc_FinishErrorReport();
  }
#endif
  flag_VALUES[FlagId] = Value;
}

static __inline__ int flag_GetFlagValue(FLAG_FLAGS FlagId)
{
  return flag_VALUES[FlagId];
}

static __inline__ int flag_StoreGetFlagValue(FLAGSTORE Store, FLAG_FLAGS FlagId)
{
  return Store[FlagId];
}


static __inline__ BOOL flag_ValueIsClean(FLAG_FLAGS FlagId)
{
  return (flag_VALUES[FlagId] == flag_CLEAN);
}

static __inline__ char* flag_Name(FLAG_FLAGS Flag)
{
#ifdef DEBUG
  if (Flag <0 || Flag >= flag_MAXFLAG) {
    misc_StartErrorReport();
    misc_ErrorReport("\n In flag_Name: Range of flags exceeded.");
    misc_FinishErrorReport();
  }
#endif
 
  return(flag_STRINGS[Flag]);
}


static __inline__ void flag_ClearInferenceRules()
{
  flag_VALUES[flag_IEMS] = 0;
  flag_VALUES[flag_ISOR] = 0;
  flag_VALUES[flag_IEQR] = 0;
  flag_VALUES[flag_IERR] = 0;
  flag_VALUES[flag_IEQF] = 0;
  flag_VALUES[flag_IMPM] = 0;
  flag_VALUES[flag_ISPR] = 0;
  flag_VALUES[flag_ISPL] = 0;
  flag_VALUES[flag_IORE] = 0;
  flag_VALUES[flag_ISRE] = 0;
  flag_VALUES[flag_IOFC] = 0;
  flag_VALUES[flag_ISFC] = 0;
  flag_VALUES[flag_IBUR] = 0;
}


static __inline__ void flag_ClearReductionRules()
{
  flag_VALUES[flag_RFREW] = 0;
  flag_VALUES[flag_RBREW] = 0;
  flag_VALUES[flag_RFCLR] = 0;
  flag_VALUES[flag_RBCLR] = 0;
  flag_VALUES[flag_ROBV]  = 0;
  flag_VALUES[flag_RTAUT] = 0;
  flag_VALUES[flag_RSST]  = 0;
  flag_VALUES[flag_RSSI]  = 0;
  flag_VALUES[flag_RFSUB] = 0;
  flag_VALUES[flag_RBSUB] = 0;
  flag_VALUES[flag_RCON]  = 0;
  flag_VALUES[flag_RRRE]  = 0;
  flag_VALUES[flag_RUNC]  = 0;
  flag_VALUES[flag_RTER]  = 0;
}

static __inline__ void flag_ActivateStdRedNoEq()
{
  flag_VALUES[flag_RFCLR] = 1;
  flag_VALUES[flag_RBCLR] = 1;
  flag_VALUES[flag_ROBV]  = 1;
  flag_VALUES[flag_RTAUT] = 1;
  flag_VALUES[flag_RFSUB] = 1;
  flag_VALUES[flag_RBSUB] = 1;
  flag_VALUES[flag_RCON]  = 1;
  flag_VALUES[flag_RUNC]  = 1;
}

static __inline__ void flag_PrintReductionRules()
{
  int i;
  printf("\n Reductions: ");
  for(i=flag_RFREW;i<=flag_RCON;i++)
    if (flag_VALUES[i])
      printf("%s ",flag_STRINGS[i]);
} 

static __inline__ void flag_PrintInferenceRules()
{
  int i;
  printf("\n Inferences: ");
  for(i=flag_IEMS;i<=flag_IBUR;i++)
    if (flag_VALUES[i])
      printf("%s ",flag_STRINGS[i]);
} 







void  flag_Init(void);
void  flag_Free(void);
void  flag_Print(void);
void  flag_FPrint(FILE*);
BOOL  flag_Lookup(const char*);
int   flag_Id(const char*);

#endif






