




 





















#include "hash.h"





LIST hash_TABLE[hash__SIZE];






void hash_Init(void)
{
  int i;
  
  for (i = 0; i < hash__SIZE; i++)
    hash_PutList(i, list_Nil());
}

void hash_Reset(void)
{
  int  i;
  LIST Scan;
  
  for (i = 0; i < hash__SIZE; i++) {
    Scan = hash_List(i);
    while (!list_Empty(Scan)) {
      list_Free(list_Car(Scan));
      Scan = list_Cdr(Scan);
    }
    list_Delete(hash_List(i));
    hash_PutList(i, list_Nil());
  }
}

void hash_ResetWithValue(void (*ValueDelete)())
{
  int  i;
  LIST Scan;
  
  for (i = 0; i < hash__SIZE; i++) {
    Scan = hash_List(i);
    while (!list_Empty(Scan)) {
      ValueDelete(list_PairSecond(list_Car(Scan)));
      list_Free(list_Car(Scan));
      Scan = list_Cdr(Scan);
    }
    list_Delete(hash_List(i));
    hash_PutList(i, list_Nil());
  }
}

POINTER hash_Get(POINTER key)
{
  LIST Scan;

  Scan = hash_List(hash_Index(key));
  
  while(!list_Empty(Scan)) {
    if (list_PairFirst(list_Car(Scan)) == key)
      return list_PairSecond(list_Car(Scan));
    Scan = list_Cdr(Scan);
  }

  return NULL;
}
