




 

























#include "misc.h"
#include "memory.h"
#include <errno.h>
#include <math.h>





void misc_ErrorReport(const char * Format, ...)
{
  va_list args;
  va_start(args,Format);
  vfprintf(misc_ERROROUT,Format,args);
  va_end(args);
}

void misc_UserErrorReport(const char * Format, ...)
{
  va_list args;
  va_start(args,Format);
  vfprintf(misc_USERERROROUT,Format,args);
  va_end(args);
}

void misc_DumpCoreOut(const char* String)

{
  fprintf(stderr, "\n %s \n", String);
  misc_DumpCore();
}


BOOL misc_StringIsNumber(const char* String)

{
  int i;
  
  if (String == NULL || String[0] == '\0')
    return FALSE;
  
  i = 0;

  while (String[i] != '\0')
    if (String[i] >= '0' && String[i] <= '9')
      i++;
    else
      return FALSE;

  return TRUE;  
}


int misc_ReturnValue(void)
{
  return 0;
}


int misc_Max(int a, int b)
{
  if (a > b)
    return a;
  else
    return b;
}

FILE* misc_OpenFile(char* Name, char* Mode)

{
  FILE* File;

  File = fopen(Name,Mode);

  if (File == (FILE*)NULL) {
    misc_StartUserErrorReport();
    misc_UserErrorReport("\n\tError in opening file %s for %s !\n\n", Name, 
			 (Mode[0] == 'r' ? "reading" :
			  (Mode[0] == 'w' ? "writing" : "i/o operations")));
    misc_FinishUserErrorReport();
  }  

  return File;
}

void misc_CloseFile(FILE* File, char* Name)

{
  int Result;

  Result = fclose(File);

  if (Result != 0) {
    misc_StartUserErrorReport();
    misc_UserErrorReport("\n\tError in closing file %s !\n\n", Name);
    misc_FinishUserErrorReport();
  }  
}


char* misc_StringCopy(const char* String)

{
  char *copy;

  copy = (char *) memory_Malloc(strlen(String)+1);
  strcpy(copy, String);
  return copy;
}

void  misc_StringFree(char* String)

{
  memory_Free(String, strlen(String)+1);
}

char* misc_IntToString(int Number)

{
  char* result;
  NAT   size = 1;

  if (Number > 9) {
    size = (NAT)log10(Number) + 1;
  } else if (Number < 0) {
    size = (NAT)log10(abs(Number)) + 2; 
  }
  size++; 

  result = (char *) memory_Malloc(sizeof(char) * size);
  sprintf(result, "%d", Number);
  return result;
}

int misc_StringToInt(const char* String)

{
  long  number;
  char* end;

  end    = (char*)String;     
  errno  = 0;
  number = strtol(String, &end, 10);
  if (errno != 0 || number > INT_MAX || number < INT_MIN) {
    
    misc_StartUserErrorReport();
    misc_UserErrorReport("\nString isn't a number or number to large: %s",
			 String);
    misc_FinishUserErrorReport();
  }
  return number;
}
