




 





















#ifndef _MISC_
#define _MISC_





#include <limits.h>
#include <stdarg.h>
#include <stdlib.h>
#include "define.h"





#if defined(TRUE)
#undef TRUE
#endif

#if defined(FALSE)
#undef FALSE
#endif

#ifndef SEEK_END
#define SEEK_END 2
#endif


#define misc_ERROROUT     stderr
#define misc_USERERROROUT stderr

typedef enum { FALSE=0, TRUE=1 } BOOL;

#define misc_VERSION "V1.0.0TPTP"


typedef void*           POINTER;
typedef unsigned int    NAT;


static const NAT NAT_MAX = UINT_MAX;






static __inline__ void misc_Error(void)
{
  fflush(misc_USERERROROUT);
  fflush(stdout);
  fflush(stderr);
  exit(EXIT_FAILURE);
}


static __inline__ void misc_DumpCore(void)
{
  fprintf(misc_ERROROUT,"\n\n");
  fflush(misc_ERROROUT);
  fflush(stdout);
  fflush(stderr);
  abort();
}


static __inline__ void misc_PrintChar(NAT Number, char Character)
{
  NAT Counter;
  for (Counter = 1; Counter <= Number; Counter++)
    putchar(Character);
}

static __inline__ BOOL misc_SmallerThan(int i, int j)
{
  return (BOOL)(i < j);
}

#define misc_StartErrorReport()  { fflush(stdout); fprintf(misc_ERROROUT,"\n\tError in file %s at line %d\n",__FILE__,__LINE__); }
#define misc_FinishErrorReport() misc_DumpCore()

#define misc_StartUserErrorReport()    fflush(stdout)
#define misc_FinishUserErrorReport()   misc_Error()






#ifdef __cplusplus
extern "C" {
#endif
void  misc_ErrorReport(const char * , ...);
void  misc_UserErrorReport(const char * , ...);

void  misc_DumpCoreOut(const char*);
BOOL  misc_StringIsNumber(const char*);
int   misc_ReturnValue(void);
int   misc_Max(int, int);

FILE* misc_OpenFile(char* , char*);
void  misc_CloseFile(FILE*, char*);

char* misc_StringCopy(const char*);
void  misc_StringFree(char*);
char* misc_IntToString(int);
int   misc_StringToInt(const char*);
#ifdef __cplusplus
}
#endif

#endif
