




 






















#ifndef _SPASS_RENAMING_
#define _SPASS_RENAMING_





#include "misc.h"
#include "foldfg.h"
#include "unify.h"
#include "vector.h"





typedef struct {
  TERM   hit;
  LIST   matches;
  int    polarity;
} *RENAMING, RENAMING_NODE;





 





static __inline__ int ren_OverallPolarity(RENAMING ren)
{
  return ren->polarity;
}

static __inline__ TERM ren_Hit(RENAMING ren)
{
  return ren->hit;
}

static __inline__ LIST ren_Matches(RENAMING ren)
{
  return ren->matches;
}

static __inline__ void ren_SetMatches(RENAMING ren, LIST matches)
{
  ren->matches = matches;
}

static __inline__ void ren_SetHit(RENAMING ren, TERM hit)
{
  ren->hit = hit;
}

static __inline__ void ren_SetOverallPolarity(RENAMING ren, int polarity)
{
  ren->polarity = polarity;
}


static __inline__ RENAMING ren_Create(TERM hit, LIST matches, int polarity)

{
  RENAMING Result;

  Result            = (RENAMING)memory_Malloc(sizeof(RENAMING_NODE));
  Result->hit       = hit;
  Result->matches   = matches;
  Result->polarity  = polarity;

  return Result;
}

static __inline__ void ren_Delete(RENAMING ren)

{
  list_Delete(ren->matches);
  memory_Free(ren,sizeof(RENAMING_NODE));
}






void ren_Init(void);
TERM ren_Rename(TERM, LIST*,BOOL, BOOL);

#endif
