


























#ifndef _RPOS_
#define _RPOS_

#include "misc.h"
#include "order.h"
#include "pqueue.h"
#include "foldfg.h"





typedef struct RPOS_TERMHELP{
  TERM                  term;
  struct RPOS_TERMHELP* parent;
  LIST                  children;
  NAT                   ord;         
  NAT                   size;        
  NAT                   count;       
  LIST                  newSubList;  
  LIST                  smaller;     
  LIST                  equal;       
  BOOL                  visited;     
} RPOS_TERMNODE, *RPOS_TERM;






BOOL       rpos_Equal(TERM, TERM);
ord_RESULT rpos_GreaterEqual(TERM, TERM);
ord_RESULT rpos_Compare(TERM, TERM);

BOOL       rpos_ContEqual(CONTEXT, TERM, CONTEXT, TERM);
ord_RESULT rpos_ContGreaterEqual(CONTEXT, TERM, CONTEXT, TERM);
ord_RESULT rpos_ContCompare(CONTEXT, TERM, CONTEXT, TERM);

void       rpos_TermPrint(RPOS_TERM);           
void       rpos_ListPrint(LIST);                





static __inline__ BOOL rpos_Greater(TERM T1, TERM T2)
{
  return ord_IsGreaterThan(rpos_GreaterEqual(T1, T2));
}

static __inline__ BOOL rpos_ContGreater(CONTEXT C1, TERM T1,
					CONTEXT C2, TERM T2)
{
  return ord_IsGreaterThan(rpos_ContGreaterEqual(C1, T1, C2, T2));
}

#endif
