




 





















#ifndef _REDRULES_
#define _REDRULES_

#include "sort.h"
#include "subsumption.h"
#include "condensing.h"
#include "search.h"
#include "rules-split.h"
#include "rules-inf.h"
#include "doc-proof.h"
#include "clock.h"





extern const NAT red_USABLE;
extern const NAT red_WORKEDOFF;
extern const NAT red_ALL;






static __inline__ BOOL red_WorkedOffMode(NAT Mode)
{
  return (Mode == red_WORKEDOFF || Mode == red_ALL);
}

static __inline__ BOOL red_OnlyWorkedOffMode(NAT Mode)
{
  return (Mode == red_WORKEDOFF);
}

static __inline__ BOOL red_UsableMode(NAT Mode)
{
  return (Mode == red_USABLE || Mode == red_ALL);
}

static __inline__ BOOL red_AllMode(NAT Mode)
{
  return (Mode == red_ALL);
}


void   red_Init();        


LIST   red_CompleteReductionOnDerivedClauses(PROOFSEARCH, LIST, BOOL, NAT, int, NAT, int*);
CLAUSE red_ReductionOnDerivedClause(PROOFSEARCH , CLAUSE , BOOL , NAT);
CLAUSE red_CompleteReductionOnDerivedClause(PROOFSEARCH , CLAUSE , BOOL, NAT);
LIST   red_BackReduction(PROOFSEARCH, CLAUSE, BOOL, NAT);
LIST   red_SatUnit(PROOFSEARCH, LIST, BOOL);
LIST   red_SatInput(PROOFSEARCH, BOOL);
LIST   red_ReduceInput(PROOFSEARCH, LIST, BOOL);
BOOL   red_ClauseDeletion(SORTTHEORY, CLAUSE);


void   red_CheckSplitSubsumptionCondition(PROOFSEARCH);


#endif
