




 





















#ifndef _SUBST_
#define _SUBST_





#include "term.h"
#include "symbol.h"
#include "list.h"





typedef struct subst {
  struct subst *next;
  SYMBOL dom;
  TERM   codomain;
} SUBST_NODE, *SUBST;


static __inline__ SUBST subst_Get(void)
{
  return (SUBST) memory_Malloc(sizeof(SUBST_NODE));
}

static __inline__ void subst_FreeOneNode(SUBST SL)
{
  memory_Free(SL, sizeof(SUBST_NODE));
}





#include "unify.h"





static __inline__ SUBST subst_Nil(void)
{
  return (SUBST)NULL;
}

static __inline__ BOOL subst_Exist(SUBST S)
{
  return S != subst_Nil();
}

static __inline__ BOOL subst_Empty(SUBST S)
{
  return S == subst_Nil();
}

static __inline__ SUBST subst_Next(SUBST S)
{
  return S->next;
}

static __inline__ void subst_SetNext(SUBST S, SUBST N)
{
  S->next = N;
}

static __inline__ SYMBOL subst_Dom(SUBST S)
{
  return S->dom;
}

static __inline__ TERM subst_Cod(SUBST S)
{
  return S->codomain;
}

static __inline__ SUBST subst_NUnion(SUBST S1,SUBST S2)
{
  SUBST Result;

  if (S1 == (SUBST)NULL)  
    return S2;        

  if (S2 == (SUBST)NULL) 
    return S1;

  Result = S1;

  for (; S1->next != (SUBST)NULL; S1 = S1->next);
            
  S1->next = S2;

  return Result; 
}






SUBST subst_Add(SYMBOL, TERM, SUBST);
void  subst_Delete(SUBST);
void  subst_Free(SUBST);





TERM  subst_Term(SYMBOL, SUBST);
TERM  subst_Apply(SUBST, TERM);
SUBST subst_Merge(SUBST, SUBST);
SUBST subst_Compose(SUBST, SUBST);
SUBST subst_Copy(SUBST);
BOOL  subst_MatchTops(const CONTEXT, SUBST);
BOOL  subst_BindVar(SYMBOL,SUBST);





BOOL subst_Unify(CONTEXT, SUBST);
BOOL subst_IsShallow(SUBST);





BOOL  subst_Match(const CONTEXT, SUBST);





BOOL  subst_MatchReverse(const CONTEXT, SUBST);





BOOL  subst_Variation(const CONTEXT, SUBST);





SUBST subst_ComGen(const CONTEXT, SUBST, SUBST*, SUBST*);





void  subst_CloseVariables(const CONTEXT, SUBST);
SUBST subst_CloseOpenVariables(SUBST);





void      subst_ExtractUnifier(const CONTEXT, SUBST*, const CONTEXT, SUBST*);
void      subst_ExtractUnifierCom(const CONTEXT, SUBST*);
SUBST     subst_ExtractMatcher(void);





void  subst_Print(SUBST);

#endif


